import 'package:detester/detester.dart';
import 'package:detester/dsl.dart';
part 'package:detester/test.dart';

suite() => [
  testArithmetics,
  testPythagoreanTriples
];

testArithmetics() {
  expect
    * "1 + 1 == 2" / (1 + 1 == 2)
    * "2 + 2 == 4" / (2 + 2 == 4)
    * "4 + 4 == 8" / (4 + 4 == 8)
    ;
}

testPythagoreanTriples() {
  var t = table * "a" * "b" * "c"
                | 3   | 4   | 5
                | 5   | 12  | 13
                | 7   | 24  | 25
                | 8   | 15  | 17
                | 9   | 40  | 41
                ;
  expect
    * "it is a triple" / ((it) => it.length == 3)
    * "it is a Pythagorean triple" / ((it) => it.a * it.a + it.b * it.b == it.c * it.c)
    < each(t);
}

