// Copyright (c) 2012, Ladislav Thon. All rights reserved. Use of this source
// code is governed by a BSD-style license that can be found in the LICENSE file.

class TestSuite {
  String name;
  List<Function> tests;
  Function before, after, beforeSuite, afterSuite;

  TestSuite(this.name, this.tests, [this.before, this.after, this.beforeSuite, this.afterSuite]);

  factory TestSuite.from(suite) {
    if (suite is TestSuite) {
      return suite;
    } else if (suite is List) {
      var script = new Options().script;
      return new TestSuite("<$script>", suite);
    } else {
      throw new ExpectException("Test suite must either be TestSuite or List of test functions");
    }
  }
}

class MultipleTestSuites {
  List suites;
  MultipleTestSuites(this.suites);
}

