// Copyright (c) 2012, Ladislav Thon. All rights reserved. Use of this source
// code is governed by a BSD-style license that can be found in the LICENSE file.

/// This file is meant to be `part`-ed in a file that
///
/// 1. `import`s `detester.dart`
/// 2. defines a top-level function called [suite], which either returns
///    a [List] of closures, or result of calling [configure].
///
/// It is also expected that the file will `import` the Dart Matchers library,
/// but strictly speaking, it isn't necessary (the user can always throw
/// ExpectException and/or AssumeException by hand).

main() {
  runSuite(suite, reporter) {
    TestRunner runner = new DefaultRunner(reporter);
    runner.run(new TestSuite.from(suite));
  }

  var configured = suite();
  if (configured is MultipleTestSuites) {
    var reporter = new MultipleSuitesAwareReporter(new ConsoleReporter());
    for (final suite in configured.suites) {
      runSuite(suite, reporter);
    }
    reporter.finish();
  } else {
    runSuite(configured, new ConsoleReporter());
  }
}

